/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.classifier;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.ztest.sets.ZClassSet;
import org.ztest.sets.ZIClassSet;

public class ZClassifier {
    public static Set<ZIClassSet> classify(Set<String> set, ZIClassifier classifier)
        throws Exception {
        Map<String, ZIClassSet> map = new HashMap<String, ZIClassSet>();

        for (String name : set) {
            Set<String> classificationSet = classifier.classify(name);
            for (String classification : classificationSet) {
                ZIClassSet cs = map.get(classification);
                if (cs == null) {
                    cs = new ZClassSet(classification);
                    map.put(classification, cs);
                }
                cs.getClasses().add(name);
            }
        }

        Set<ZIClassSet> ret = new HashSet<ZIClassSet>(map.values());
        return ret;
    }
}
