/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.classifier;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.ztest.sets.ZIClassSet;

public class ZClassifyByClassSets implements ZIClassifier {

    private Map<String, Set<String>> classification = new HashMap<String, Set<String>>();

    public ZClassifyByClassSets(Set<ZIClassSet> classSets)
        throws Exception {
        for (ZIClassSet cs : classSets) {
            for (String name : cs.getClasses()) {
                Set<String> crt = classification.get(name);
                if (crt == null) {
                    crt = new HashSet<String>();
                    classification.put(name, crt);
                }
                crt.add(cs.getName());
            }
        }
    }

    public Set<String> classify(String name)
        throws Exception {
        Set<String> ret = classification.get(name);
        if (ret == null) {
            ret = new HashSet<String>();
        }
        return ret;
    }
}
