/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.classinfo;

import java.util.List;
import java.util.Set;

import org.ztest.jdom.ZWriteXML;

/**
 *
 * class repository, keeps the class data and data about relationships between
 * classes.
 *
 * @author gerdziegler.de
 *
 */
public interface ZIClassInfo extends ZWriteXML, java.io.Serializable {
    public ZIClassEdge addEdge(String name1, String name2)
        throws Exception;

    public ZIClassEdge addEdgeAndNode(String name1, String name2)
        throws Exception;

    public void addClass(String name)
        throws Exception;

    public Set<String> getClasses()
        throws Exception;

    public Set<String> getClasses(ZIClassFilter filter)
        throws Exception;

    public ZIClassEdge getEdge(String t1, String t2)
        throws Exception;

    public Set<ZIClassEdge> getEdges()
        throws Exception;

    public Set<ZIClassEdge> getPredecessorEdges(String name, boolean transitive)
        throws Exception;

    public Set<ZIClassEdge> getPredecessorEdges(String name, ZIClassEdgeFilter filter, boolean transitive)
        throws Exception;

    public Set<ZIClassEdge> getPredecessorEdges(Set<String> set, ZIClassEdgeFilter filter, boolean transitive)
        throws Exception;

    public Set<ZIClassEdge> getSuccessorEdges(String name, ZIClassEdgeFilter filter, boolean transitive)
        throws Exception;

    public Set<ZIClassEdge> getSuccessorEdges(String name, boolean transitive)
        throws Exception;

    public Set<ZIClassEdge> getSuccessorEdges(Set<String> set, ZIClassEdgeFilter filter, boolean transitive)
        throws Exception;

    public Set<ZIClassEdge> getEdges(ZIClassEdgeFilter edgeFilter)
        throws Exception;

    public ZIClassMeta getClassMeta(String name)
        throws Exception;

    public boolean isInstanceof(String name, String superClassName)
        throws Exception;

    public Set<String> getClassesInstanceof(String className)
        throws Exception;

    public Set<String> getSuperclasses(String className)
        throws Exception;

    public List<Set<String>> getCycles()
        throws Exception;

    public ZIPath getShortestPath(String v1, String v2)
        throws Exception;

    public boolean isAnnotatedWith(String className, String annotationClassName)
        throws Exception;

    public Set<String> getClassesAnnotatedWith(final String annotationClassName)
        throws Exception;

    public Set<String> getPredecessors(Set<String> classes, boolean transitive)
        throws Exception;

    public Set<String> getSuccessors(Set<String> classes, boolean transitive)
        throws Exception;

    public Set<String> getScannedClasses()
        throws Exception;

    public Set<String> getPredecessors(String name, boolean transitive)
        throws Exception;

    public Set<String> getSuccessors(String name, boolean transitive)
        throws Exception;

    public Set<String> getSuccessors(Set<String> set, ZIClassEdgeFilter filter, boolean transitive)
        throws Exception;

    public Set<String> getSuccessors(String item, ZIClassEdgeFilter filter, boolean transitive)
        throws Exception;

    public Set<String> getPredecessors(Set<String> set, ZIClassEdgeFilter filter, boolean transitive)
        throws Exception;

    public Set<String> getPredecessors(String item, ZIClassEdgeFilter filter, boolean transitive)
        throws Exception;

    public boolean isSuccessor(String user, String used, boolean transitive)
        throws Exception;

    public boolean isSuccessor(String user, String used, ZIClassEdgeFilter filter, boolean transitive)
        throws Exception;

    public boolean isPredecessor(String user, String used, boolean transitive)
        throws Exception;

    public boolean isPredecessor(String user, String used, ZIClassEdgeFilter filter, boolean transitive)
        throws Exception;

    public boolean isClass(String name)
        throws Exception;

    public boolean isEdge(String name1, String name2)
        throws Exception;
}
