/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.classinfo.impl;

import org.jdom.Element;
import org.ztest.classinfo.ZILocation;
import org.ztest.classinfo.ZIManifest;
import org.ztest.jdom.ZXMLUtil;

public class ZLocation implements ZILocation {
    private final String name;

    private final ZIManifest manifest;

    ZLocation(String name, ZIManifest manifest) {
        this.name = name;
        this.manifest = manifest;
    }

    public String getName() {
        return name;
    }

    public Element toElement()
        throws Exception {
        Element ret = new Element("location");
        ret.setAttribute("name", name);
        return ret;
    }

    public String toXML()
        throws Exception {
        return ZXMLUtil.toXML(toElement());
    }

    public int compareTo(ZILocation o) {
        return name.compareTo(o.getName());
    }

    public ZIManifest getManifest() {
        return manifest;
    }
}
