/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.classinfo.ser;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.util.zip.ZipInputStream;

import org.apache.log4j.Logger;
import org.ztest.classinfo.ZIClassInfo;

public class ZClassInfoSerReader {
    private Logger log = Logger.getLogger(ZClassInfoSerReader.class);

    private final InputStream inputStream;
 
    public ZClassInfoSerReader(InputStream inputStream) {
        this.inputStream = inputStream;
    }
 
    public ZClassInfoSerReader(File file) throws FileNotFoundException {
        this(new BufferedInputStream(new FileInputStream(file), 16 * 1024));
    }

    public ZIClassInfo read()
        throws Exception {
        ZipInputStream zip = new ZipInputStream(inputStream);
        zip.getNextEntry();
        ObjectInputStream in = new ObjectInputStream(zip);
        ZIClassInfo classInfo = (ZIClassInfo)in.readObject();
        in.close();
        return classInfo;
    }
}
