/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.classinfo.ser;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import org.apache.log4j.Logger;
import org.ztest.classinfo.ZIClassInfo;

public class ZClassInfoSerWriter {
    private Logger log = Logger.getLogger(ZClassInfoSerWriter.class);

    private final OutputStream outputStream;

    public ZClassInfoSerWriter(OutputStream outputStream) {
        this.outputStream = outputStream;
    }

    public ZClassInfoSerWriter(File file)
        throws FileNotFoundException {
        this(new BufferedOutputStream(new FileOutputStream(file), 16 * 1024));
    }

    public void write(ZIClassInfo classInfo)
        throws Exception {
        ZipOutputStream zip = new ZipOutputStream(outputStream);
        ZipEntry ze = new ZipEntry("classinfo.ser");
        zip.putNextEntry(ze);
        ObjectOutputStream os = new ObjectOutputStream(zip);
        os.writeObject(classInfo);
        os.flush();
        zip.closeEntry();
        zip.close();
    }
}
