/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.filter;

import org.ztest.classinfo.ZIClassEdge;
import org.ztest.classinfo.ZIClassEdgeFilter;
import org.ztest.classinfo.ZIClassFilter;

public class ZClassEdgeFilterByClassFilter implements ZIClassEdgeFilter {
    private final ZIClassEdgeFilter next;

    final ZIClassFilter classFilter;

    public ZClassEdgeFilterByClassFilter(ZIClassFilter classFilter) {
        this(classFilter, new ZClassEdgeFilterAcceptAll());
    }

    public ZClassEdgeFilterByClassFilter(ZIClassFilter classFilter, ZIClassEdgeFilter next) {
        super();
        this.classFilter = classFilter;
        this.next = next;
    }

    public boolean accept(ZIClassEdge edge)
        throws Exception {
        if (edge.isLoop()) {
            return false;
        }
        return classFilter.accept(edge.getSource()) && classFilter.accept(edge.getTarget()) && next.accept(edge);
    }
}
