/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.filter;

import java.util.Set;

import org.ztest.classinfo.ZIClassEdge;
import org.ztest.classinfo.ZIClassEdgeFilter;

public class ZClassEdgeFilterByEdges implements ZIClassEdgeFilter {
    final Set<ZIClassEdge> edges;

    private final ZIClassEdgeFilter next;

    public ZClassEdgeFilterByEdges(Set<ZIClassEdge> edges) {
        this(edges, new ZClassEdgeFilterAcceptAll());
    }

    public ZClassEdgeFilterByEdges(Set<ZIClassEdge> edges, ZIClassEdgeFilter next) {
        super();
        this.next = next;
        this.edges = edges;
    }

    public boolean accept(ZIClassEdge edge)
        throws Exception {
        if (edge.isLoop()) {
            return false;
        }
        return edges.contains(edge) && next.accept(edge);
    }
}
