/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.filter;

import org.ztest.classinfo.ZClassUtils;
import org.ztest.classinfo.ZIClassEdge;
import org.ztest.classinfo.ZIClassEdgeFilter;

public class ZClassEdgeFilterRemoveInnerClassEdges implements ZIClassEdgeFilter {
    private final ZIClassEdgeFilter next;

    public ZClassEdgeFilterRemoveInnerClassEdges() {
        this(new ZClassEdgeFilterAcceptAll());
    }

    public ZClassEdgeFilterRemoveInnerClassEdges(ZIClassEdgeFilter next) {
        super();
        this.next = next;
    }

    public boolean accept(ZIClassEdge edge)
        throws Exception {
        if (edge.isLoop()) {
            return false;
        }
        if (ZClassUtils.getTopClassName(edge.getSource()).equals(ZClassUtils.getTopClassName(edge.getTarget()))) {
            return false;
        }
        return next.accept(edge);
    }
}
