package org.ztest.filter;

import org.ztest.classinfo.ZIClassEdge;
import org.ztest.classinfo.ZIClassEdgeFilter;

public class ZCompoundClassEdgeFilter implements ZIClassEdgeFilter {
    private final ZIClassEdgeFilter filter1;
    private final ZIClassEdgeFilter filter2;

    public ZCompoundClassEdgeFilter(ZIClassEdgeFilter filter1, ZIClassEdgeFilter filter2) {
        super();
        this.filter1 = filter1;
        this.filter2 = filter2;
    }

    public boolean accept(ZIClassEdge edge)
        throws Exception {
        if (filter1 != null && !filter1.accept(edge)) {
            return false;
        }
        return filter2 == null || filter2.accept(edge);
    }
}
