package org.ztest.filter;

import org.ztest.classinfo.ZIClassFilter;

public class ZCompoundClassFilter implements ZIClassFilter {
    private final ZIClassFilter filter1;
    private final ZIClassFilter filter2;

    public ZCompoundClassFilter(ZIClassFilter filter1, ZIClassFilter filter2) {
        super();
        this.filter1 = filter1;
        this.filter2 = filter2;
    }

    public boolean accept(String name)
        throws Exception {
        if (!filter1.accept(name)) {
            return false;
        }
        return filter2.accept(name);
    }
}
