package org.ztest.filter;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.ztest.classinfo.ZIClassEdge;
import org.ztest.classinfo.ZIClassEdgeFilter;
import org.ztest.classinfo.ZIClassFilter;

public class ZFilterUtil {
    public static List<Set<String>> filter(Collection<Set<String>> coll, ZIClassFilter filter)
        throws Exception {
        List<Set<String>> ret = new ArrayList<Set<String>>();
        for (Set<String> set : coll) {
            Set<String> filtered = filter(set, filter);
            if (filtered.size() > 1) {
                ret.add(filtered);
            }
        }
        return ret;
    }

    public static Set<String> filter(Set<String> classes, ZIClassFilter filter)
        throws Exception {
        Set<String> ret = new HashSet<String>();

        for (String s : classes) {
            if (filter.accept(s)) {
                ret.add(s);
            }
        }

        return ret;
    }

    public static Set<ZIClassEdge> filter(Set<ZIClassEdge> edges, ZIClassEdgeFilter filter)
        throws Exception {
        Set<ZIClassEdge> ret = new HashSet<ZIClassEdge>();

        for (ZIClassEdge s : edges) {
            if (filter.accept(s)) {
                ret.add(s);
            }
        }

        return ret;
    }

    public static Set<String> getClasses(Set<ZIClassEdge> edges, ZIClassFilter filter)
        throws Exception {
        Set<String> ret = new HashSet<String>();

        for (ZIClassEdge s : edges) {
            if (filter.accept(s.getSource())) {
                ret.add(s.getSource());
            }
            if (filter.accept(s.getTarget())) {
                ret.add(s.getTarget());
            }
        }

        return ret;
    }

}
