/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.output.graphml.style;

import java.awt.Color;

public class ZStyleUtil {
    public static String computeColor(Color col) {
        int rgb = col.getRGB();
        String s = Integer.toHexString(rgb);
        s = s.substring(1);
        while (s.length() < 7) {
            s += "0";
        }
        if (s.length() > 6) {
            s = s.substring(0, 6);
        }
        return "#" + s;
    }

    public static String computeColor(int r, int g, int b) {
        return computeColor(new Color(r, g, b));
    }

    public static Color getRandomColorMin(int rmin, int gmin, int bmin) {
        return getRandomColor(rmin, 255, gmin, 255, bmin, 255);
    }

    public static Color getRandomColorMax(int rmax, int gmax, int bmax) {
        return getRandomColor(255, rmax, 255, gmax, 255, bmax);
    }

    public static Color getRandomColor(int rmin, int rmax, int gmin, int gmax, int bmin, int bmax) {
        int r1 = rmin + (int)((double)(rmax - rmin) * Math.random());
        int g1 = gmin + (int)((double)(gmax - gmin) * Math.random());
        int b1 = bmin + (int)((double)(bmax - bmin) * Math.random());
        return new Color(r1, g1, b1);
    }
}
