/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.sets;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

import org.ztest.classinfo.ZIClassFilter;

public class ZFilterClassSet extends ZAbstractClassSet {
    protected final ZIClassSet classSet;

    protected final ZIClassFilter filter;

    public ZFilterClassSet(String name, ZIClassSet classSet, ZIClassFilter filter)
        throws Exception {
        super(name);
        this.classSet = classSet;
        this.filter = filter;
    }

    public Set<String> getClasses()
        throws Exception {
        Set<String> ret = new HashSet<String>();

        for (String name : classSet.getClasses()) {
            if (filter.accept(name)) {
                ret.add(name);
            }
        }

        return Collections.unmodifiableSet(ret);
    }
}
