/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.sets.ejb3;

import java.util.Set;

import org.ztest.classinfo.ZIClassFilter;
import org.ztest.classinfo.ZIClassInfo;
import org.ztest.sets.ZClassSet;

public class ZStatefulSessionBean3Set extends ZClassSet {
    protected final ZIClassInfo classInfo;

    public ZStatefulSessionBean3Set(String name, ZIClassInfo classInfo)
        throws Exception {
        super(name);
        this.classInfo = classInfo;
        initClasses();
    }

    protected void initClasses()
        throws Exception {
        ZIClassFilter filter = new ZIClassFilter() {
            public boolean accept(String name)
                throws Exception {
                return ZEJB3Util.isStatefulSessionBean(classInfo, name);
            }
        };
        Set<String> classes = classInfo.getClasses(filter);
        getClasses().addAll(classes);
    }
}
