/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.tests;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.ztest.classinfo.ZIClassEdge;
import org.ztest.classinfo.ZIClassEdgeFilter;

public class ZClassEdgeFilterByFailures implements ZIClassEdgeFilter {
    final Set<ZIClassEdge> edges = new HashSet<ZIClassEdge>();

    public ZClassEdgeFilterByFailures(List<? extends ZITestFailure> failures)
        throws Exception {
        for (ZITestFailure f : failures) {
            edges.addAll(f.getRelatedEdges());
        }
    }

    public boolean accept(ZIClassEdge edge) {
        if (edge.isLoop()) {
            return false;
        }
        return edges.contains(edge);
    }
}
