/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.tests;

import java.util.HashSet;
import java.util.Set;

import org.jdom.Element;
import org.jdom.Text;
import org.ztest.classinfo.ZIClassEdge;
import org.ztest.jdom.ZXMLUtil;

public class ZEmptyFailure implements ZITestFailure {
    private final String className;

    public ZEmptyFailure(String className) {
        this.className = className;
    }

    public Element toElement() {
        Element ret = new Element("class");
        ret.addContent(new Text(className));
        return ret;
    }

    public String toString() {
        return toXML();
    }

    public String toXML() {
        return ZXMLUtil.toXML(toElement());
    }

    public Set<String> getRelatedClasses() {
        Set<String> ret = new HashSet<String>();
        ret.add(className);
        return ret;
    }

    public Set<ZIClassEdge> getRelatedEdges() {
        Set<ZIClassEdge> ret = new HashSet<ZIClassEdge>();
        return ret;
    }
}
