/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.tests;

import java.util.HashSet;
import java.util.Set;

import org.jdom.Element;
import org.jdom.Text;
import org.ztest.classinfo.ZIClassEdge;
import org.ztest.jdom.ZXMLUtil;

public class ZGenericFailure implements ZITestFailure {
    private final String name;

    private final String className;

    public ZGenericFailure(final String name, final String className) {
        super();
        this.name = name;
        this.className = className;
    }

    public Element toElement() {
        Element root = new Element(name);
        root.addContent(new Text(className.toString()));
        return root;
    }

    public String toString() {
        return toXML();
    }

    public String toXML() {
        return ZXMLUtil.toXML(toElement());
    }

    public int compareTo(ZITestFailure tf) {
        if (!(tf instanceof ZGenericFailure)) {
            return -1;
        }

        ZGenericFailure gf = (ZGenericFailure)tf;
        return className.compareTo(gf.className);
    }

    public String getClassName() {
        return className;
    }

    public String getName() {
        return name;
    }

    public Set<String> getRelatedClasses() {
        Set<String> ret = new HashSet<String>();
        return ret;
    }

    public Set<ZIClassEdge> getRelatedEdges() {
        Set<ZIClassEdge> ret = new HashSet<ZIClassEdge>();
        return ret;
    }
}
