/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.tests;

import org.apache.log4j.Logger;
import org.ztest.classinfo.ZIClassInfo;
import org.ztest.sets.ZIClassSet;

public class ZPackageTest extends ZClassSetTest<ZPackageFailure> {
    static final Logger log = Logger.getLogger(ZPackageTest.class);

    private final String packageName;

    public ZPackageTest(String name, ZIClassInfo classInfo, ZIClassSet classes, String packageName) {
        super(name, classInfo, classes);
        this.packageName = packageName;
    }

    public ZPackageTest(ZIClassInfo classInfo, ZIClassSet classes, String packageName) {
        this("package-test", classInfo, classes, packageName);
    }

    public void run()
        throws Exception {
        for (String name : getFilteredClasses()) {
            if (!name.substring(0, name.lastIndexOf('.')).equals(packageName)) {
                getFailures().add(new ZPackageFailure(getClassInfo(), name, packageName));
            }
        }
    }

    public String getPackageName() {
        return packageName;
    }
}
