package org.ztest.tests;

import java.util.ArrayList;
import java.util.List;

import org.jdom.Element;
import org.ztest.classinfo.ZIClassInfo;
import org.ztest.jdom.ZXMLUtil;

public abstract class ZTest<F extends ZITestFailure> implements ZITest {
    private final ZIClassInfo classInfo;

    private final String name;

    private final List<F> failures = new ArrayList<F>();

    public ZTest(String name, ZIClassInfo classInfo) {
        super();
        this.name = name;
        this.classInfo = classInfo;
    }

    public String toXML()
        throws Exception {
        return ZXMLUtil.toXML(toElement());
    }

    public Element toElement()
        throws Exception {
        Element ret = new Element(name);
        ret.addContent(ZTestUtil.toElement(failures));
        return ret;
    }

    public List<F> getFailures() {
        return failures;
    }

    public ZIClassInfo getClassInfo() {
        return classInfo;
    }

    public String getName() {
        return name;
    }
}
