/*
 * Copyright 2008 Gerd Ziegler (www.gerdziegler.de) Licensed under the Apache
 * License, Version 2.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law
 * or agreed to in writing, software distributed under the License is
 * distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License. @author
 * www.gerdziegler.de
 */
package org.ztest.tests;

import java.util.Set;

import org.apache.log4j.Logger;
import org.ztest.classinfo.ZIClassInfo;
import org.ztest.sets.ZIClassSet;

public class ZUnusedClassesTest extends ZClassSetTest<ZUnusedClassesFailure> {
    static final Logger log = Logger.getLogger(ZUnusedClassesTest.class);

    public ZUnusedClassesTest(String name, ZIClassInfo classInfo, ZIClassSet set) {
        super(name, classInfo, set);
    }

    public ZUnusedClassesTest(ZIClassInfo classInfo, ZIClassSet set) {
        this("unused-classes-test", classInfo, set);
    }

    public void run()
        throws Exception {

        for (String c : getFilteredClassesSorted()) {
            Set<String> pred = getClassInfo().getPredecessors(c, false);
            pred.remove(c);

            if (pred.isEmpty()) {
                getFailures().add(new ZUnusedClassesFailure(c));
            }
        }
    }
}
